from __future__ import print_function
from __future__ import division
from builtins import range
from past.utils import old_div
import numpy as np

__testmode = False


MODS = 32
MOD_PER_LINE = 4
##MODS = 128
##MOD_PER_LINE = 8
CHANNELS = 32
AUX_CHANNELS = 3

X_SIZE = 32
Y_SIZE = 32
##X_SIZE = 64
##Y_SIZE = 64

TESTMODE_CHANNELS = 35
TESTMODE_AUX_CHANNELS = 0

##if __testmode :
##    X_SIZE = MODS
##    Y_SIZE = CHANNELS


# module number to its position (from bottom left in a zig-zag sequence by MOD_PER_LINE)
model_A = {
### channel number (not counting auxiliary channels) to connector pin (not counting grounds)
##    'b':[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,31,30,29,28,27,26,25,24,23,22,21,20,19,18,17,16],
##
### connector pin (not counting grounds) to pixel  x-y position on substrate (from bottom left corner)
##    'c':[(0,1),(0,2),(0,0),(0,3),\
##         (1,1),(1,2),(1,0),(1,3),\
##         (2,1),(2,2),(2,0),(2,3),\
##         (3,1),(3,2),(3,0),(3,3),\
##         (4,1),(4,2),(4,0),(4,3),\
##         (5,1),(5,2),(5,0),(5,3),\
##         (6,1),(6,2),(6,0),(6,3),\
##         (7,1),(7,2),(7,0),(7,3)],
    'map': [(0, 1), (0, 2), (0, 0), (0, 3), (1, 1), (1, 2), (1, 0), (1, 3), (2, 1), (2, 2), (2, 0), (2, 3), (3, 1), (3, 2), (3, 0), (3, 3), (7, 3), (7, 0), (7, 2), (7, 1), (6, 3), (6, 0), (6, 2), (6, 1), (5, 3), (5, 0), (5, 2), (5, 1), (4, 3), (4, 0), (4, 2), (4, 1)],
# substrate dimensions
    'size': (8,4)}

xxx = [[19, 23, 25, 27],
       [18, 22, 20, 28],
       [16, 21, 24, 26],
       [1, 31, 13, 29],
       [17, 0, 15, 30],
       [2, 7, 14, 8],
       [3, 4, 11, 9],
       [5, 6, 10, 12]]

x =[]
for i,k in enumerate(xxx):
    for j,l in enumerate(k):
        x.append((l,i,j))

model_B = {
# channel number to pixel  x-y position on substrate (from bottom left corner)


    'map': [(i[1],i[2]) for i in sorted(x)],

# substrate dimensions
    'size': (8,4)}

model_C = {
## channel number (not counting auxiliary channels) to connector pin (pins 1, 34 - COMA)
##    b=[17,15,13,11,9,3,5,7,2,4,6,8,10,12,14,16,19,21,23,25,27,33,31,29,32,30,28,26,24,22,20,18] 
## connector pin (not counting COMA) to pixel  x-y position on substrate (from top left corner)
## c =[(3, 4), (3, 2), (3, 5), (3, 1), (3, 6), (3, 0), (3, 7), (3, 3), (2, 5), (2, 3), (2, 4), (2, 2), (2, 7), (2, 1), (2, 6), (2, 0), (1, 7), (1, 0), (1, 6), (1, 1), (1, 5), (1, 3), (1, 4), (1, 2), (0, 7), (0, 0), (0, 6), (0, 1), (0, 5), (0, 3), (0, 4), (0, 2)]

    'map': [(2, 0), (2, 1), (2, 2), (2, 3), (3, 3), (3, 2), (3, 1), (3, 0), (3, 4), (3, 5), (3, 6), (3, 7), (2, 5), (2, 4), (2, 7), (2, 6), (1, 0), (1, 1), (1, 3), (1, 2), (0, 0), (0, 2), (0, 3), (0, 1), (0, 4), (0, 5), (0, 6), (0, 7), (1, 4), (1, 5), (1, 6), (1, 7)],
# substrate dimensions
    'size': (4,8)
}

model_D = {
## symmetric "blue" substrates.
     'map': [(4, 0), (4, 1), (5, 1), (5, 0), (6, 1), (7, 0), (7, 1), (6, 0), (6, 3), (6, 2), (7, 3), (7, 2), (5, 3), (5, 2), (4, 2), (4, 3), (3, 0), (3, 1), (2, 1), (2, 0), (0, 1), (1, 0), (1, 1), (0, 0), (0, 3), (0, 2), (1, 3), (1, 2), (2, 3), (2, 2), (3, 2), (3, 3)],
#    'map': [(3, 3), (3, 2), (2, 2), (2, 3), (1, 2), (0, 3), (0, 2), (1, 3), (1, 0), (1, 1), (0, 0), (0, 1), (2, 0), (2, 1), (3, 1), (3, 0), (4, 3), (4, 2), (5, 2), (5, 3), (7, 2), (6, 3), (6, 2), (7, 3), (7, 0), (7, 1), (6, 0), (6, 1), (5, 0), (5, 1), (4, 1), (4, 0)],
# substrate dimensions
    'size': (8,4)
}



def pixelmap(controller,model="B",modules=None, chain=None, channels=None, aux = None):
    """ generates mapping from i index of data string to x,y coordinates of the image"""

    global MODS, MOD_PER_LINE, CHANNELS, AUX_CHANNELS,X_SIZE,Y_SIZE
    
    MODS = modules if modules is not None else MODS
    MOD_PER_LINE = chain  if chain is not None else MOD_PER_LINE
    CHANNELS = channels if channels is not None else CHANNELS
    AUX_CHANNELS = aux if aux is not None else AUX_CHANNELS

    

    if __testmode :
        k =0
        X_SIZE = MODS
        Y_SIZE = TESTMODE_CHANNELS

        nmap = np.zeros((X_SIZE,Y_SIZE),np.uint16)
        
        for i in range(MODS):
            k+=TESTMODE_AUX_CHANNELS                                             
            for j in range(TESTMODE_CHANNELS):
                nmap[i,j]=k
                k+=1
    elif model =="A":
        c = model_A
        
        assert MODS % MOD_PER_LINE == 0
        X_SIZE = c['size'][0]*MOD_PER_LINE
        Y_SIZE = old_div(c['size'][1]*MODS,MOD_PER_LINE)
        
        nmap = np.zeros((X_SIZE,Y_SIZE),np.uint16)
        
      #Opal Kelly
        a = [(i%MOD_PER_LINE, old_div(MODS,MOD_PER_LINE) - 1 - old_div(i,MOD_PER_LINE)) for i in range(MODS)]

        
        k =0
        for i in range(MODS):
            k+=AUX_CHANNELS                                             
            for j in range(CHANNELS):
                x=X_SIZE-1-(a[i][0]*c['size'][0]+c['map'][j][0])                   # moving (0,0) to right bottom
                y=a[i][1]*c['size'][1]+ c['map'][j][1] # if controller == "tbus_ti" else csize[1]-1-c[b[j]][1])
                nmap[x,y]=k
                k+=1
    elif model =="C":
        c = model_C

        assert MODS % MOD_PER_LINE == 0
        X_SIZE = old_div(c['size'][1]*MODS,MOD_PER_LINE)
        Y_SIZE = c['size'][0]*MOD_PER_LINE        
        a = [(i%MOD_PER_LINE,old_div(i,MOD_PER_LINE)) for i in range(MODS)]

        nmap = np.zeros((X_SIZE,Y_SIZE),np.uint16)
        

        k =0
        
        for i in range(MODS):
            k+=AUX_CHANNELS                                             
            for j in range(CHANNELS):
                y=(a[i][0]*c['size'][0]+c['map'][j][0])
                x=(a[i][1]*c['size'][1]+ c['map'][j][1])
                nmap[x,y]=k
                k+=1
    elif model =="D" :               
        c = model_D

        assert MODS % MOD_PER_LINE == 0
        X_SIZE = old_div(c['size'][1]*MODS,MOD_PER_LINE)
        Y_SIZE = c['size'][0]*MOD_PER_LINE        
        a = [(i%MOD_PER_LINE,old_div(i,MOD_PER_LINE)) for i in range(MODS)]

        nmap = np.zeros((X_SIZE,Y_SIZE),np.uint16)
        

        k =0
        
        for i in range(MODS):
            k+=AUX_CHANNELS                                             
            for j in range(CHANNELS):
                y=(a[i][0]*c['size'][0]+c['map'][j][0])
                x=(a[i][1]*c['size'][1]+ c['map'][j][1])
                nmap[x,y]=k
                k+=1
    else:               #default - model "B"
        if model != "B":
            import sys
            print("Unknown model '"+model+"', using default, model 'B'.",file=sys.stderr)
        c = model_B

        assert MODS % MOD_PER_LINE == 0
        X_SIZE = old_div(c['size'][1]*MODS,MOD_PER_LINE)
        Y_SIZE = c['size'][0]*MOD_PER_LINE        
        a = [(i%MOD_PER_LINE,old_div(i,MOD_PER_LINE)) for i in range(MODS)]

        nmap = np.zeros((X_SIZE,Y_SIZE),np.uint16)
        

        k =0
        
        for i in range(MODS):
            k+=AUX_CHANNELS                                             
            for j in range(CHANNELS):
                y=(a[i][0]*c['size'][0]+c['map'][j][0])
                x=(a[i][1]*c['size'][1]+ c['map'][j][1])
                nmap[x,y]=k
                k+=1

        
    return nmap
     
