#!/usr/bin/env python3
from terasense import processor as tp
from terasense import worker as tw

source = tp.processor()
convert = tw.Worker(size = (source.X_SIZE,source.Y_SIZE))
source.SetExposure(3)

#In the multithreaded case you need to start data acquisition explicitly
source.start()

for i in range(100):
    data = source.read()
    if data is None:
        continue
    img = convert.makeImg(data)
    #do something with image
    print(img)
    
#Call stop() to stop acquisition and join the acquisition and processing thread
source.stop()


