#!/usr/bin/env python3
from terasense import processor as tp

def ticker(progress):
    if progress < 100:
        print(".",end="")
    else:
        print(" ")
    return (True, False)

source = tp.processor()

input("Prepare to record background. Switch off incoming radiation and press Enter")
#Background is recorded for all exposures, it will take several minutes.
# May be you'll want to use SaveConfig/LoadConfig to avoid repeating the procedure.
source.RecordBG(callback = ticker)

input("Prepare to record normalization. Switch on incoming radiation and press Enter")
#Do not forget to select desired exposure.
source.SetExposure(5)
# Normalization recording may raise an Exception if illumination condition are detected to be unsuitable.
try:
    source.RecordNorm(callback = ticker)
except Exception as e:
    print(e)
    
#You are free to change exposure - all backgrounds are stored.
source.SetExposure(3)
source.start()
for i in range(100):
    data = source.read()
    #do something with data
source.stop() #call stop() to stop acquisition and join the acquisition and processing thread
