from builtins import str
import wx
import random, math

_test = True


# GUI Options panel class
class OptionsPanel(wx.Panel):
    """"Class VideoPanel"""
    def __init__(self,parent,id, main = None, processor = None):

        

        super(OptionsPanel, self).__init__(parent=parent,id=id)

        if not main:
            self.main = parent.GetParent()
        else:
            self.main = main

        self.processor = processor
#  Panel Options

        

        vbox = wx.BoxSizer(wx.VERTICAL)

##        hbox = wx.BoxSizer(wx.HORIZONTAL)
        hbox = wx.StaticBoxSizer(wx.StaticBox(self), wx.HORIZONTAL)

        self.negative = wx.CheckBox(self, label="Negative", name="negative")
        self.Bind(wx.EVT_CHECKBOX, self.OnNegative, id=self.negative.GetId())
        self.negative.SetValue(False)
        hbox.Add( self.negative, proportion=0, flag=wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        hbox.Add((1,0), proportion=1)
        
        self.mirror = wx.CheckBox(self, label="Mirror", name="mirror")
        self.mirror.SetValue(False)
        self.Bind(wx.EVT_CHECKBOX, self.OnMirror, id=self.mirror.GetId())
        hbox.Add( self.mirror, proportion=0, flag=wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        hbox.Add((1,0), proportion=1)




        self.falsecolor = wx.CheckBox(self, label="Color", name="falsecolor")
        self.falsecolor.SetValue(True)
        self.Bind(wx.EVT_CHECKBOX, self.OnFalseColor, id=self.falsecolor.GetId())
        hbox.Add( self.falsecolor, proportion=0, flag=wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        

        vbox.Add( hbox, proportion=1,flag=wx.EXPAND)



        if self.main.dev:

            hbox = wx.StaticBoxSizer(wx.StaticBox(self), wx.HORIZONTAL)
            
            self.stitch = wx.CheckBox(self, label="Stitch", name="stitch")
            self.Bind(wx.EVT_CHECKBOX, self.OnStitch, id=self.stitch.GetId())
            self.stitch.SetValue(True)
            hbox.Add( self.stitch, proportion=1, flag=wx.EXPAND|wx.ALIGN_CENTER)
            
            self.greedy = wx.CheckBox(self, label="Greedy", name="greedystitch")
            self.Bind(wx.EVT_CHECKBOX, self.OnGreedyStitch, id=self.greedy.GetId())
            self.greedy.SetValue(True)
            hbox.Add( self.greedy, proportion=1, flag=wx.EXPAND|wx.ALIGN_CENTER)

            self.grid = wx.CheckBox(self, label="Draw grid", name="grid")
            self.Bind(wx.EVT_CHECKBOX, self.OnGrid, id=self.grid.GetId())
            self.grid.SetValue(False)
            hbox.Add( self.grid, proportion=1, flag=wx.EXPAND|wx.ALIGN_CENTER)

            ##            hbox.Add((1,0), proportion=1)
            vbox.Add( hbox, proportion=1,flag=wx.EXPAND)



        hbox = wx.StaticBoxSizer(wx.StaticBox(self), wx.HORIZONTAL)        
        self.diff = wx.CheckBox(self, label="Difference", name="diff")
        self.Bind(wx.EVT_CHECKBOX, self.OnDifference, id=self.diff.GetId())
        self.diff.SetValue(False)
        hbox.Add( self.diff, proportion=0, flag=wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)


        vbox.Add( hbox, proportion=1)
        
        hbox = wx.BoxSizer(wx.HORIZONTAL)

        self.smooth = wx.CheckBox(self, label="Smooth", name="smooth")
        self.Bind(wx.EVT_CHECKBOX, self.OnSmooth, id=self.smooth.GetId())
        self.smooth.SetValue(True)
        hbox.Add( self.smooth,proportion=0, flag=wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)

#        vbox.Add( hbox, proportion=1)
        
        self.smoothness = wx.Slider(self, style=wx.SL_TOP |wx.SL_AUTOTICKS, value=50,name="smoothness")
        self.smoothness.SetTickFreq(50)
        if self.smooth.IsChecked():
            self.smoothness.Enable()
        else:
            self.smoothness.Disable()
        self.Bind(wx.EVT_SLIDER, self.OnChangeSmoothness, id=self.smoothness.GetId())
#        vbox.Add( self.smoothness,flag=wx.ALIGN_CENTER|wx.EXPAND)
        hbox.Add( self.smoothness,proportion=1,flag=wx.ALIGN_CENTER_VERTICAL)

        self.median = wx.CheckBox(self, label="Median", name="median")
        self.Bind(wx.EVT_CHECKBOX, self.OnMedian, id=self.median.GetId())
        self.median.SetValue(False)
        if self.smooth.IsChecked():
            self.median.Enable()
        else:
            self.median.Disable()
        hbox.Add( self.median,proportion=0, flag=wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        
        vbox.Add( hbox, proportion=1,flag=wx.EXPAND)

        hbox = wx.BoxSizer(wx.HORIZONTAL)
        self.accumulate = wx.CheckBox(self, label="Accum.", name="accumulate")
        self.Bind(wx.EVT_CHECKBOX, self.OnAccumulate, id=self.accumulate.GetId())
        self.accumulate.SetValue(False)
        hbox.Add( self.accumulate, flag=wx.EXPAND|wx.ALIGN_CENTER)
        self.accuLength = wx.SpinCtrl(self, size=(50,20), value=str(self.processor.GetAccuLength()), min=1,max=100, name="accuLength")
        if self.accumulate.IsChecked():
            self.accuLength.Enable()
        else:
            self.accuLength.Disable()
        self.Bind(wx.EVT_SPINCTRL, self.OnChangeAccuLength, id=self.accuLength.GetId())
        hbox.Add( self.accuLength, proportion=2, flag=wx.ALIGN_CENTER_VERTICAL)
        
        vbox.Add( hbox, proportion=1)
        
       

##        choices = ["Off","On"]
##        self.bgSelect = wx.RadioBox(self,label="Background", choices=choices, name="bgSelect",majorDimension=3, style=wx.RA_SPECIFY_COLS)
##        self.Bind(wx.EVT_RADIOBOX, self.OnBGSelect, id=self.bgSelect.GetId())
##
##        self.bgSelect.SetSelection(1)
##
##        vbox.Add( self.bgSelect, proportion=0, flag=wx.EXPAND)

        xbox = wx.StaticBoxSizer(wx.StaticBox(self,label="Config"), wx.VERTICAL)
        hbox = wx.BoxSizer(wx.HORIZONTAL) 
        self.bgRecord = wx.Button(self,-1, 'Rec. BG...')
        self.Bind(wx.EVT_BUTTON, self.OnRecordBG, id=self.bgRecord.GetId())
        hbox.Add( self.bgRecord, proportion=1, flag=wx.ALIGN_CENTER)
        self.normRecord = wx.Button(self,-1, 'Rec. Norm...')
        self.Bind(wx.EVT_BUTTON, self.OnRecordNorm, id=self.normRecord.GetId())
        hbox.Add( self.normRecord, proportion=1, flag=wx.ALIGN_CENTER)

        xbox.Add(hbox, proportion=1, flag=wx.EXPAND)
        xbox.Add((0,8), proportion=0)

        hbox = wx.BoxSizer(wx.HORIZONTAL) 
        self.configSave = wx.Button(self,-1, 'Save config...')
        self.Bind(wx.EVT_BUTTON, self.OnSaveConf, id=self.configSave.GetId())
        hbox.Add( self.configSave, proportion=1, flag=wx.ALIGN_CENTER)

        self.configLoad = wx.Button(self,-1, 'Load config...')
        self.Bind(wx.EVT_BUTTON, self.OnLoadConf, id=self.configLoad.GetId())
        hbox.Add( self.configLoad, proportion=1, flag=wx.ALIGN_CENTER)
       
        xbox.Add(hbox, proportion=1, flag=wx.EXPAND)
        
        vbox.Add( xbox, proportion=1, flag=wx.EXPAND)


        d = self.processor.GetNormList()
        if self.main.dev: 
            self.normKeys = ['none']+list(d.keys())
        else:
            self.normKeys = list(d.keys())
        self.normSelect = wx.RadioBox(self,label="Normalization", choices=self.normKeys, name="normSelect",majorDimension=3, style=wx.RA_SPECIFY_COLS)
        for i,k in enumerate(self.normKeys):
            if k in d:
                self.normSelect.EnableItem(i,d[k])

        self.normSelect.SetStringSelection(self.processor.GetSelectedNorm() or 'none')
         
            
        self.Bind(wx.EVT_RADIOBOX, self.OnNormSelect, id=self.normSelect.GetId())
        vbox.Add( self.normSelect, proportion=0, flag=wx.EXPAND)
        
        hbox = wx.BoxSizer(wx.HORIZONTAL)
        
        
        vbox.Add( hbox, proportion=1)

        
        self.SetSizerAndFit(vbox)

        

    def Initialize(self):
        self.OnSmooth()
        self.OnMedian()

##        if self.main.dev:
##            self.OnStitch()
##            self.OnGreedyStitch()
        self.OnDifference()
        self.OnFalseColor()
        self.OnNegative()
        self.OnMirror()

        self.OnAccumulate()

        self.OnNormSelect()


    def OnStart(self):
        self.Initialize()
        self.bgRecord.Enable(False)
        self.normRecord.Enable(False)

    def OnStop(self):
        self.bgRecord.Enable(True)
        self.normRecord.Enable(True)
        pass


           
    def OnChangeSmoothness(self,event):
        
        if self.main.worker:
            self.main.worker.SetSmoothness(float(self.smoothness.GetValue()))
            
        
    def OnSmooth(self,event=None):
        if self.smooth.IsChecked():
            self.smoothness.Enable()
            self.median.Enable()
        else:
            self.smoothness.Disable()
            self.median.Disable()
    
        if self.smooth.IsChecked() :
            self.main.worker.processFlags |= self.main.worker.SMOOTH
        else :
            self.main.worker.processFlags &= ~self.main.worker.SMOOTH

    def OnMedian(self,event=None):
    
        if self.median.IsChecked() :
            self.main.worker.processFlags |= self.main.worker.MEDIAN
        else :
            self.main.worker.processFlags &= ~self.main.worker.MEDIAN

    def OnGreedyStitch(self,event=None):
        try:
            self.processor.SetGreedyStitch(self.greedy.IsChecked())
        except:
            self.processor.SetGreedyStitch()

    def OnGrid(self,event=None):
        try:
            self.main.image.drawGrid = self.grid.IsChecked()
        except:
            pass
            
    def OnStitch(self,event=None):
        try:
            on = self.stitch.IsChecked()
            self.processor.SetStitch(on)
            self.greedy.Enable(on)
        except:
            self.processor.SetStitch()
        

    def OnFalseColor(self,event=None):
        if self.falsecolor.IsChecked() :
            self.main.worker.SetFC(True)
        else :
            self.main.worker.SetFC(False)

    def OnNegative(self,event=None):
        if self.main.worker:
            if self.negative.IsChecked() :
                self.main.worker.processFlags |= self.main.worker.NEGATIVE
            else :
                self.main.worker.processFlags &= ~self.main.worker.NEGATIVE
                
    def OnDifference(self,event=None):
        on =  self.diff.IsChecked() 
        self.processor.SetDifference(on)
        if on:
            try:
                self.main.status.SetStatusText("Difference mode",0)
            except:
                pass
        else:
            try:
                self.main.status.SetStatusText("",0)
            except:
                pass
                
    def OnMirror(self,event=None):
        if self.mirror.IsChecked() :
            self.main.worker.processFlags |= self.main.worker.MIRROR
        else :
            self.main.worker.processFlags &= ~self.main.worker.MIRROR


    def OnAccumulate(self,event=None):
        on =  self.accumulate.IsChecked()       
        self.accuLength.Enable(on)
        self.processor.SetAccumulation(on)
    


    def OnChangeAccuLength(self,event=None):
        self.processor.SetAccuLength(float(self.accuLength.GetValue()))
           

##    def OnBGSelect(self, event=None):
##        x=self.bgSelect.GetSelection()
##        if x == 0:
##            self.processor.SelectBG(None)
##        else:
##            self.processor.SelectBG(self.processor.GetExposure())

            
    
    def OnRecordBG(self,event):
        s = "Recording background data.\nPlease, wait while recording finishes."
        dialog =  wx.ProgressDialog(title="Recording Dialog",message=s, style=wx.PD_AUTO_HIDE|wx.PD_APP_MODAL|wx.PD_CAN_ABORT|wx.PD_ELAPSED_TIME)
        wx.BeginBusyCursor()
        self.processor.RecordBG(callback = dialog.Update)
        wx.EndBusyCursor()
        dialog.Destroy()
                      

        
    def OnRecordNorm(self,event):
        s = "Recording normalization data.\nPlease, wait while recording finishes."
        dialog =  wx.ProgressDialog(title="Recording Dialog",message=s, style=wx.PD_AUTO_HIDE|wx.PD_APP_MODAL|wx.PD_CAN_ABORT|wx.PD_ELAPSED_TIME)
        wx.BeginBusyCursor()
        try:
            self.processor.RecordNorm(callback = dialog.Update)
        except Exception as e:
##            self.main.OnError(e)
            dlg = wx.MessageDialog(None, str(e)+"\n\nDo you want to record normalization data anyway?" , 'Warning', wx.YES_NO| wx.CANCEL | wx.ICON_ERROR)
            result = dlg.ShowModal()
            dlg.Destroy()
            if result == wx.ID_YES:
                self.processor.RecordNorm(callback = dialog.Update,force=True)
        
        wx.EndBusyCursor()
        dialog.Destroy()

        d = self.processor.GetNormList()
        for i,k in enumerate(self.normKeys):
            if k in d:
                self.normSelect.EnableItem(i,d[k])
        self.normSelect.SetStringSelection(self.processor.GetSelectedNorm())
                
    def OnSaveConf(self,event):
        wc = "Configuration data (*.zip)|*.zip|All files|*.*"

        # Create an save file dialog
        fileDialog = wx.FileDialog ( None, wildcard = wc, style = wx.FD_SAVE | wx.FD_OVERWRITE_PROMPT )
        if fileDialog.ShowModal() == wx.ID_OK:
            out = fileDialog.GetPath()
            msg = "Saving configuration data to the file\n\n"+out+"\n\nPlease, wait."
            wx.BeginBusyCursor()
            progressDialog = wx.ProgressDialog("Please, wait...",msg,10)
            progressDialog.ShowModal()
            progressDialog.Pulse()
            try:
                if hasattr(progressDialog,"UpdatePulse"):
                    self.processor.SaveConfig(out, progressDialog.UpdatePulse)
                else:
                    self.processor.SaveConfig(out, progressDialog.Pulse)
                msg = "Configuration data saved successfully to the file\n\n"+out
                stl = wx.OK | wx.ICON_INFORMATION
            except Exception as e:
                msg = "Saving configuration data to the file\n\n"+out+"\n\nfailed:"+str(e)
                stl = wx.OK | wx.ICON_ERROR
            finally:
                wx.EndBusyCursor()
                progressDialog.Update(10)
                progressDialog.Destroy()
                wx.MessageBox(message = msg, style = stl)
        fileDialog.Destroy()
       

    def OnLoadConf(self,event):
        wc = "Configuration data (*.zip)|*.zip|All files|*.*"
        fileDialog = wx.FileDialog ( None, wildcard = wc, style = wx.FD_OPEN  )
        if fileDialog.ShowModal() == wx.ID_OK:
            out = fileDialog.GetPath()
            msg = "Loading configuration data from the file\n\n"+out+"\n\nPlease, wait."
            wx.BeginBusyCursor()
            progressDialog = wx.ProgressDialog("Please, wait...",msg,10)
            progressDialog.ShowModal()
            progressDialog.Pulse()
            try:
                if hasattr(progressDialog,"UpdatePulse"):
                    self.processor.LoadConfig(out, progressDialog.UpdatePulse)
                else:
                    self.processor.LoadConfig(out, progressDialog.Pulse)
                d = self.processor.GetNormList()
                for i,k in enumerate(self.normKeys):
                    if k in d:
                        self.normSelect.EnableItem(i,d[k])
                self.normSelect.SetStringSelection(self.processor.GetSelectedNorm() or 'none')
                msg = "Configuration data from the file\n"+out+"\nhave been loaded successfully."
                stl = wx.OK | wx.ICON_INFORMATION
            except Exception as e:
                msg = "Loading configuration data from the file\n"+out+"\nfailed:\n"+str(e)
                stl = wx.OK | wx.ICON_ERROR
            finally:
                wx.EndBusyCursor()
                progressDialog.Update(10)
                progressDialog.Destroy()
                wx.MessageBox(message = msg, style = stl)
        fileDialog.Destroy()
                


    def OnNormSelect(self, event=None):
        self.processor.SelectNorm(self.normSelect.GetStringSelection())
        
            
