from __future__ import print_function
from __future__ import division
from __future__ import absolute_import
from builtins import chr
from builtins import str
from builtins import range
from builtins import object
from past.utils import old_div
import sys
# from string import strip
from importlib import import_module
import struct
import threading
import numpy as np
import itertools
from .tbus import tbus_if as tbus_if
from .tbus import ts32  as ts32a
# from .tbus import tbus_ok as tbus_ok

from .tbus.config import tbus_conf as tbus_conf
from .tbus.config import ts_conf as ts_conf
import terasense.config.pixel_config as pc

import time


test = False

TEST_CHAIN = 16
TEST_OK_CHANNELS=2
TEST_CHANNELS = 32
TEST_MODEL = "D"
TEST_R = 0.5

NORM = -1024.

##def makeTest(i):
##        import random
##        if i % (2*(pc.AUX_CHANNELS+pc.CHANNELS)) == 1:
##            c =chr(4)
##        elif i % (2*(pc.AUX_CHANNELS+pc.CHANNELS)) == 0:
##            c =chr(0)
##        elif i % (2*(pc.AUX_CHANNELS+pc.CHANNELS)) in range(2*pc.AUX_CHANNELS):
##            c =chr(0)
##        else:
##            i -= 2*pc.AUX_CHANNELS*(i/(2*(pc.AUX_CHANNELS+pc.CHANNELS))+1)
##            val = int(float(i/(2*pc.CHANNELS))/(pc.MODS-1)*TEST_R*1024)+int(float((i/2)%pc.CHANNELS)/(pc.CHANNELS-1)*(1-TEST_R)*1024)
##
##            if val == 0:
##                c=chr(0)    
##            elif i % 2 ==1 :
##                c = chr(0xFF^(val/256))
##            else :
##                c = chr(0xFF^(val%256)) 
##        
##        return c

def makeTest(i):
        import random
        if i % (2*(pc.AUX_CHANNELS+pc.CHANNELS)) == 1:
            c =4
        elif i % (2*(pc.AUX_CHANNELS+pc.CHANNELS)) == 0:
            c =0
        elif i % (2*(pc.AUX_CHANNELS+pc.CHANNELS)) in range(2*pc.AUX_CHANNELS):
            c =0
        else:
            i -= 2*pc.AUX_CHANNELS*(old_div(i,(2*(pc.AUX_CHANNELS+pc.CHANNELS)))+1)
            val = (old_div(i,2))%pc.CHANNELS

            if val == 1:
                c=0    
            elif i % 2 ==1 :
                c = 0xF0
            else :
                c = 0x00 
        
        return c


class deviceEnumerator(object):
    """Creates a list of the available devices. The list should be updated manually if necessary"""
    ctl = None
    devices = {}
    def __init__(self):
        self.update()
        
    def update(self):
        """Updates the device list and returns the list of IDs (serial numbers)."""
        tbus_conf.controller = "terasense.tbus.tbus_ok"           
        self.ctl = tbus_if.tbus_ctl.create(tbus_conf)
        ids={}
        for i in range(self.ctl.get_dev_count()):
            a = self.ctl.get_ctl_serial(i)
            if not self.ctl.init_core(a):
                continue
            newid = self.ctl.get_id()
            if newid.find('/') != -1:
                newid = newid.split('/')[0]
            elif newid.find('_') != -1:
                newid = newid.split('_')[0]
            else:
                continue
            ids[newid] = {'oksn':a}
            self.ctl.close()
        self.devices=ids
        return sorted(self.devices)

    def devCount(self):
        """Returns the number of devices found during the last update."""
        return len(self.devices)
    
    def getDevList(self):
        """Returns the list of IDs (serial numbers) of the devices found during the last update."""
        return sorted(self.devices)

    def getOKSN(self,sn):
        """Returns serial number of Opal Kelly controller corrsponding to Terasense ID (serial number, like ok101010), if currently available.
Returns empty string otherwise. For internal use."""
        return self.devices.get(sn,{'oksn':''}).get('oksn','')

class interface(object):
    def __init__(self,threaded=True, sn=''):
        conf_file = ts_conf.def_ts32a_config
        self.conf = import_module("."+conf_file,"terasense.tbus")
        self.threaded = threaded
        
        if self.threaded:
            self.lock = threading.Lock()
        self.timing = [(7,0),(6,0),(5,0),(4,0),(3,0),(2,0),(1,0),(0,0),(0,1),(0,2),(0,3)]  #timer_frame, timer_clk_div        
        
        self.exposure = int(old_div(len(self.timing),2))
        
        self.type = ""
        self.model = ""

        self.norm = NORM 
        
        if not test:

            tbus_conf.controller = "terasense.tbus.tbus_ok"                # Opal Kelly
            self.ctl = tbus_if.tbus_ctl.create(tbus_conf)

            oksn = ''  # serial number of OpalKelly controller to be opened
            if sn:
                de = deviceEnumerator()
                if sn in de.getDevList():
                    oksn = de.getOKSN(sn)
                else:
                    raise RuntimeError('Device {} is not connected or busy.'.format(sn))

            res = True
            try:
                res = self.ctl.init(port = oksn)
            except RuntimeError as e:
                raise RuntimeError('Cannot open the device {}: {}'.format(sn,str(e))) from None
            finally:
                if not res:
                    raise RuntimeError('Cannot open the device {}. It is not connected or busy.'.format(sn))
                
            id_string = self.ctl.get_id()
            if id_string.find('/') != -1:
                tokens = id_string.split('/')
            else:
                tokens = id_string.split('_')
            self.id = tokens[0].strip()

            if len(tokens) > 1:
                self.type = tokens[1].strip()
            
            if len(tokens) > 2:
                self.model = tokens[2].strip()
                if self.model not in ["A","B","C","D"]:
                    self.model = ""
                        
            ts32a.configure(self.ctl, self.conf)
                    
            self.map = pc.pixelmap(tbus_conf.controller,model=self.model,modules=self.ctl.cfg.ok_channels*self.ctl.chain, chain=self.ctl.chain, channels=self.ctl.ver[1])
#            print("Selfmap", len(self.map), self.map.shape)
            self.controller = tbus_conf.controller

            if self.conf.no_cdc == 1:
                    self.norm = abs(NORM) #


        else:
            self.ctl = tbus_if.tbus_ctl(tbus_conf)
            self.ctl.chain = TEST_CHAIN
            self.ctl.cfg.ok_channels = TEST_OK_CHANNELS
            self.ctl.ver = (1,TEST_CHANNELS)
            self.id = "test_id"
            tbus_conf.controller = "test"

            self.type ="line"

            self.map = pc.pixelmap(tbus_conf.controller,model=TEST_MODEL,modules=self.ctl.cfg.ok_channels*self.ctl.chain, chain=self.ctl.chain, channels=self.ctl.ver[1])
            self.controller = "test"
            self.testpattern = (pc.MODS,bytearray([ makeTest(i) for i in range(2*(pc.AUX_CHANNELS+pc.CHANNELS)*pc.MODS)]) ) # test pattern

     
        if self.type[0:4] == "line":
            self.X_SIZE = old_div(pc.X_SIZE,2)
            self.Y_SIZE = pc.Y_SIZE*2
            temp = np.ndarray((self.X_SIZE,self.Y_SIZE),dtype=np.int)
            temp[0:self.X_SIZE,pc.Y_SIZE:self.Y_SIZE]=self.map[0:self.X_SIZE,0:pc.Y_SIZE]
            temp[0:self.X_SIZE,0:pc.Y_SIZE]=np.fliplr(np.flipud(self.map[self.X_SIZE:pc.X_SIZE,0:pc.Y_SIZE]))
            if self.type == "line":
                self.map = np.flipud(temp)
            elif self.type in ["line_","line_t2"]:
                self.map = np.fliplr(temp)
            else:
                self.map = temp
        
        else:
            self.X_SIZE = pc.X_SIZE
            self.Y_SIZE = pc.Y_SIZE
            if self.type in ["l1"]:
                self.map = np.flipud(self.map)
            

    def info(self,detailed=False):
        if not test:
                return self.ctl.info(detailed)
        else:
                return "Test controller"

    def get_id(self):

        return self.id

    def SetExposure(self,exp):
        error = self._setexp(exp)
        return error

    def reset(self):
        if test:
            return
        if self.threaded :
            self.lock.acquire()        
        ts32a.configure(self.ctl, self.conf)
        if self.threaded :
            self.lock.release()


    def _setexp(self,exp):
        old_pars = self.conf.timer_frame, self.conf.timer_clk_div
        error = None
        
        self.conf.timer_frame, self.conf.timer_clk_div = self._time_pars(exp)

        

        self.conf.reset_time = self._reset_time(exp)
        self.conf.int_time = self._inttime(exp)

        self.conf.read_delay = 0.0

        error = False
        if not test:
            try:
                self.reset()
                self.exposure = exp
            except RuntimeError as e:
                error = e
                print(str(error),file=sys.stderr)
                self.conf.timer_frame, self.conf.timer_clk_div = old_pars
                self.conf.reset_time = self._reset_time(self.exposure)
                self.conf.int_time = self._inttime(self.exposure)        
                self.conf.read_delay = self._read_delay()
        else:
            self.exposure = exp
       
        return error

        

    def GetExposure(self):
        return self.exposure

    def GetExposureRange(self):
        return (0,len(self.timing)-1)

    def _inttime(self, exposure = -1):
        """ Returns integration time  in timer clock periods (see ts32a_conf) """
        if exposure < 0:
            exposure = self.exposure
        tf, cd = self._time_pars(exposure)

        return int( (1<<(16-tf))*(1.-1./(2<<(self._reset_time(exposure))))- old_div(float(((4<<self.conf.adc_sh_time) if self.conf.adc_sh_time < 3 else 64)+ 16)*(self.conf.adc_clk_div+1),(1<<cd)) ) # 16 - adc conversion time in adc10clk periods plus timer syncronization overhead

    def _read_delay(self):
        return (1<<(16-self.conf.timer_frame))*(pc.AUX_CHANNELS+pc.CHANNELS)*(1<<self.conf.timer_clk_div)/float(self.conf.master_clk)  #4MHz main clock

    def _reset_time(self,exposure=-1):
        if exposure < 0:
            exposure = self.exposure
        tf, cd = self._time_pars(exposure)

        a = 9+cd-tf
        return a if a<=7 else 7

    def _time_pars(self,exposure=-1):
        """Returns time_frame, timer_clk_div"""
        if exposure < 0:
            exposure = self.exposure
        return self.timing[exposure]        

    def GetIntTime(self,exposure=-1):
        """ Returns integration time in microseconds """
        if exposure < 0:
            exposure = self.exposure        
        tf, cd = self._time_pars(exposure)
        return self._inttime(exposure)*(1<<cd)/float(self.conf.master_clk)

    def GetDimensions(self):
        """ Returns matrix dimensions as a tuple """
        return (self.X_SIZE, self.Y_SIZE)

    def read(self):
        """ Reads data from controller into a new numpy.ndarray and returns it.
The function acquires interface.lock for the duration of its operation if threaded."""
        data =  np.empty((self.X_SIZE,self.Y_SIZE),dtype=np.float32)

        error = self.read2buffer(data)
 #       print("Interface read:", data)
        if error:
                print(str(error),file=sys.stderr)
 #      print("Marker Interface:") 
        return data

    def read_raw(self):
        """ Reads raw data string from controller"""
        if test:
            return self.testpattern
        else:
            return ts32a.acquire_raw(self.ctl, self.conf)                                                # actual readout
        
    def read2buffer(self,data):
        """ Reads data from controller into a buffer.
Buffer should be a numpy.ndarray with dtype float32 and appropriate size (use interface.GetDimensions()).
The function acquires interface.lock for the duration of its operation if threaded."""
        
        assert len(data) == self.X_SIZE and len(data[0]) == self.Y_SIZE

 #       print("Empty data_me", data)

        try:
            if test:
                x = self.testpattern
            else:
                
                x = ts32a.acquire_raw(self.ctl, self.conf)                                                # actual readout
        except Exception as e:
                return e


            
        # t=np.fromstring(x[1],dtype=np.int16)
        # t=np.fromstring(x[1][0],dtype=np.int16)
        # t = int.from_bytes(x[1][0], byteorder='little', signed=False)
        # t = np.frombuffer(x[1][0], dtype=np.int16)
        t = np.frombuffer(x[1], dtype=np.int16)
        # print("some t:", x)
        
        if self.threaded:
            self.lock.acquire()
        np.take(t.astype(np.float32),self.map,axis=0,out=data,mode='clip')

        np.divide(data,self.norm,data)

        if self.threaded:
            self.lock.release()
        
        return False

    def auto2buffer(self,data, callback):
        def proxy(x):
            if self.threaded:
                self.lock.acquire()
            # t=np.fromstring(x[1],dtype=np.int16)
            # t = np.frombuffer(x[1][0], dtype=np.int16)
            t = np.frombuffer(x[1], dtype=np.int16)
            np.take(t.astype(np.float32),self.map,axis=0,out=data,mode='clip')

            np.divide(data,self.norm,data)
            if self.threaded:
                self.lock.release()

            return callback()

        if test:
            while True:
                time.sleep(old_div(self.GetIntTime()*32,1e6))
                if proxy(self.testpattern):
                    break
                
        else:
            proxy(self.read_raw())
            self.ctl.bus_read_auto(2*(pc.AUX_CHANNELS+pc.CHANNELS), proxy)
