#
# Sensor pixel arrangement configuration
#

# The number of pixels in image row
pixels_in_row = 8

# The module pixels arrangement in terms of channel indexes
mod_pixels = (
	( 3,  4,  5,  6,  7,  8,  9, 10),
	(11, 12, 13, 14, 15, 16, 17, 18),
	(19, 20, 21, 22, 23, 24, 25, 26),
	(27, 28, 29, 30, 31, 32, 33, 34)
)

# The module area width and height calculated from the above definition
mod_w = len(mod_pixels[0])
mod_h = len(mod_pixels)

assert pixels_in_row % mod_w == 0

# Get the (module_index, module_origin) tuple given the pixel row, column along with the total number of pixels.
# The module_origin is the tuple containing the minimum row, column values of the module pixels (module's top left corner).
def mod_resolver(r, c, total_pixels):
	i, j = r // mod_h, c // mod_w
	return i * (pixels_in_row / mod_w) + j, (i * mod_h, j * mod_w)


# The following transformation may be applied to the resulting image
# in the order they are described.

# Flip image in left-right direction
# image_fliplr = True
image_fliplr = False

# Flip image in up-down direction
# image_flipud = True
image_flipud = False

# Transpose the resulting image so rows will become columns and vise versa
# image_transpose = True
image_transpose = False
