# import os
#
# T-BUS controller configuration file
#

# The controller specification
#controller = 'tbus_ti' # Texas Instruments
# curDir = os.path.dirname(os.path.abspath(__file__))
controller = 'tbus_ok' # Opal Kelly

##ok_fw_folder = '../../ok/tbmc'
ok_fw_folder = './ok'

def ok_on_load(ctl):
    global ok_fw_path,ok_channels
    
    ctl_id = ctl.get_id()
    if ctl_id.find('/') != -1:

                s = ctl_id.split('/')
    else:
                s = ctl_id.split('_')
    try:
                # Initialize firmware path
                if s[1] == '4' or s[1] == '8':
                        ok_fw_path = ok_fw_folder+'/tbus_controller_%s.bit' % s[1]
                        ok_channels = int(s[1])
                elif s[1] == '16':
                        ok_fw_path = ok_fw_folder+'/tbus_controller.bit'
                        ok_channels = int(s[1])
                elif s[1] == '4x':
                        ok_fw_path = ok_fw_folder+'/tbus_controller_4_.bit'
                        ok_channels = 4
                elif s[1] == '4b':
                        ok_fw_path = ok_fw_folder+'/tbus_controller_4b.bit'
                        ok_channels = 4
                elif s[1] == '8x':
                        ok_fw_path = ok_fw_folder+'/tbus_controller_8_.bit'
                        ok_channels = 8
                elif s[1] == '16x':
                        ok_fw_path = ok_fw_folder+'/tbus_controller_16_.bit'
                        ok_channels = 16
                elif s[1] == '1':
                        ok_fw_path = ok_fw_folder+'/tbus_controller_8_.bit'
                        ok_channels = 1
                elif s[1] == 'line':
                        ok_fw_path = ok_fw_folder+'/tbus_controller_4.bit'
                        ok_channels = 2
                elif s[1] == 'line_':
                        ok_fw_path = ok_fw_folder+'/tbus_controller_8.bit'
                        ok_channels = 2
                elif s[1] == 'l1':
                        ok_fw_path = ok_fw_folder+'/tbus_controller_8.bit'
                        ok_channels = 1
                elif s[1] == 'line_t2':
                        ok_fw_path = ok_fw_folder+'/tbus_controller_8_.bit'
                        ok_channels = 2
                elif s[1] == 'l1_t':
                        ok_fw_path = ok_fw_folder+'/tbus_controller_8_.bit'
                        ok_channels = 1
    except:
                pass


# The firmware path for the opal kelly controller (relative to the tools directory)
ok_fw_path = './ok/tbus_controller.bit' # Default path
#ok_fw_path = './ok/tbus_controller_8_.bit' # Default path

# Opal kelly interface library version
ok_version = '4.2'

# The number of active channels for the opal kelly controller


ok_channels = 16
#ok_channels = 2

# Enable using of on board opal kelly controller LEDs
ok_use_leds = False

# Skip command cookies to improve performance
skip_cmd_cookies = True

# Skip SQR status check to improve performance
skip_srq_status_check = True

# Serial communication timeout in seconds
com_timeout = 10

#
# Bus timing
#

# Bus bit frequency in Hz. It must divide the controller master clock = 24MHz.

tbus_freq = 4000000

#
# The following idle intervals are expressed in units equal to 1/2 bus clock period.
# They must be greater than 0 and less than 256
#

# The byte transmission idle interval
tbus_tx_idle = 128

# The byte transmission idle interval in turbo mode
tbus_turbo_idle = 32

# The byte transmission idle interval during wait
tbus_wt_idle = 255

# Use turbo mode
tbus_turbo = True

# Use 16 bit mode
tbus_16bit_mode = True

# The bus reset timeout in msec
tbus_rst_tout = 200

# The bus SRQ timeout in msec
tbus_srq_tout = 10000

# The bus command timeout in msec
tbus_cmd_tout = 10000
