#
# TS32 data acquisition config
# The master clock frequency is 4MHz
master_clk = 4.
#
def on_load(ctl):
	global code_path, no_cdc
	ctl_id = ctl.get_id()
	if ctl_id.find('/') != -1:
            s = ctl_id.split('/')
	else:
            s = ctl_id.split('_')
	# Initialize code path
	if len(s) > 2:
            if s[2].lower() == 'a':
                    code_path = './ts32bin/ts32a2.txt'
            else:
                    ode_path = './ts32bin/ts32b2.txt'
	if s[0]=='test':
            no_cdc = 1

# The path to the code (relative to the tools directory)
code_path = './ts32bin/ts32b2.txt'      # Default path

# ADC clock divider.
#  0: /1, .. , 6: /7, 7: /8
adc_clk_div = 1# 

# ADC sample and hold time in ADC clock units
#  0: 4, 1: 8, 2: 16, 3: 64
adc_sh_time = 3#   128 master clock periods = 32us

# Timer clock divider
#  0: /1, 1: /2, 2: /4, 3: /8
timer_clk_div = 0 # 4MHz

# Frame time in timer clock periods
#  0: 2^16, 1: 2^15, .. , 7: 2^9
timer_frame = 1 # 

# The integration time in timer clock periods
int_time = 20000 # 0.5msec

# Reset time in timer clock periods
#  0: frame/2, 1: frame/4, .. , 7: frame/2^8
reset_time = 5 # last 1/2^6 of the frame

# Set to 1 to disable double sampling
no_cdc = 0

# Set to 1 to measure internal temperature sensor output instead of real input
temp_test = 0

# Set to 1 to use full VCC as reference
vcc_ref = 1

# Wait before reading results (sec)
read_delay = 0

# Optionally update config on the particular iteration
def on_start(i): return True

# Note that the applet report error if integration time + conversion time exceeds the frame time - reset time
# The output data order is the following:
#  0        value measured with integrator off
#  1        value measured with zero input
#  2        value measured with test input
#  3 .. 34  values from channels 0 .. 31 measured






