#
# TS32 data acquisition config
# The master clock frequency is 4MHz
#

# The path to the code (relative to the tools directory)
code_path = '../../tmodule/applet/ts32/Release/Exe/ts32a.txt'

# ADC clock divider.
#  0: /1, .. , 6: /7, 7: /8
adc_clk_div = 7 # 0.5MHz 24usec conv time

# ADC sample and hold time in ADC clock units
#  0: 4, 1: 8, 2: 16, 3: 64
adc_sh_time = 3 # 128usec

# Timer clock divider
#  0: /1, 1: /2, 2: /4, 3: /8
timer_clk_div = 2 # 1MHz

# Frame time in timer clock periods
#  0: 2^16, 1: 2^15, .. , 7: 2^9
timer_frame = 0 # 64msec

# The integration time in timer clock periods
int_time = 30000 # 10msec

# Reset time in timer clock periods
#  0: frame/2, 1: frame/4, .. , 7: frame/2^8
reset_time = 1 # last 1/4 of the frame

# Wait before reading results (sec)
read_delay = 0

# Optionally update config on the particular iteration
def on_start(i):
	global int_time
	int_time = 1000 * (i + 1)
	return i < 32

# Note that the applet report error if integration time + conversion time exceeds the frame time - reset time
# The output data order is the following:
#  0        value measured with integrator off
#  1        value measured with zero input
#  2        value measured with test input
#  3 .. 34  values from channels 0 .. 31 measured





