#
# Terasense tools common configuration file
#

# Default acquisition config
def_ts32a_config = 'config.ts32a_conf'

# Shot to shot interval (in seconds)
shot_interval = 0.1

# Initial size of the viewer window. Set to None to maximize it.
# viewer_wnd_size = None
viewer_wnd_size = (400, 400)

# The vertical axis limits. Set to None to autoscale.
# viewer_ylim = (0, 1024)
viewer_ylim = None

# The margin for vertical axis autoscaling
viewer_ylim_margin = 1

# The time axis range (in seconds). Set to None if unlimited.
#time_range = 10
time_range = None

# The filename template for saving channel data. Arguments for %d are module and channel index.
# Set to None to disable saving file on exit.
# channel_data_file = None
channel_data_file = 'ts%d.%d.dat'

# Output file line formatting template
channel_data_file_line = '%f %f\n'

# The template for plot line label. Set to None to disable labels.
# channel_label = None
channel_label = '%d.%d'

#
# The channel data preprocessing function. Several examples are below.
#
# The simplest form - no channel processing:
#def channel_data(d, m, c): return d[m, c]

# Subtract reference channel and invert
ref_channel = 1
def channel_data(d, m, c): return d[m, ref_channel] - d[m, c]

# Pixel config name
pix_config = 'config.pix_conf'
